function lowercaseURLScheme(url)
{
	var scheme_pos = url.indexOf("://");

	if (scheme_pos >= 0)
	{
		var scheme_string = url.substring(0, scheme_pos);
		
		url = scheme_string.toLowerCase() + url.substring(scheme_pos, url.length);
	}

	return url;
}

function switchMassDeleteModeOff(element)
{
	$(".mass-delete-mode-visible").hide();
	$(".mass-delete-mode-hidden").show();
	$("#mass-delete-button").attr("data-state","0")
}

function openQrCodePopup(hash)
{
	//window.open(TinyCC.qrDownload(hash), "_blank", 'location=yes');
	var url = TinyCC.qrShow(hash);
	$("#qrCodeImage").attr("src",url);
	$("#download-qr-code").attr("href",TinyCC.qrDownload(hash));
	$("#qrCodePopup").attr("data-url-hash",hash);
	$("#qrCodePopup").popup( "open" );
}

$(document).ready(function(){
	
/**
 * Login action
 */	
	$("#login-form").submit(function(event){
		var user = $("#login-form input[name=user]").val();
		var pass = $("#login-form input[name=pass]").val();
		AccountModel.login(user, pass);
		event.preventDefault();
	});
	
/**
 * Logout action
 */
	$("#logout-button").click(function(event){
		AccountModel.logout();
	});
	
	
/**
 * URL shortening
 */
    $("#shorten-form").submit(function(event){
		var longUrlElement = $("input[name=long-url]",this);
		var customElement = $("input[name=custom-hash]",this);
		//var needStats = $("input[name='log-stats']",this).prop("checked") ? 1 : 0;
		var needStats = 1; //$("select[name='log-stats'] option:selected",this).val();
		
		var longUrl = lowercaseURLScheme(longUrlElement.val());
		longUrlElement.val(longUrl);
		
		var self = this;
		TinyCC.shorten({
			"url": longUrl,
			"customHash": customElement.val(),
			"needStats": needStats,
			"successCallback": function(response){
				MessageBox.show("URL shortened successfully!");
				//console.log(response);
				var urlEntry = response.results;
				urlEntry.longUrl = longUrl;
				RecentList.add(urlEntry);
				
				longUrlElement.val("");
				customElement.val("");
				/*$("select[name='log-stats'] option",self).prop("selected",0);
				$("select[name='log-stats'] option[value=0]",self).prop("selected",1);*/
			},
			"errorCallback": function(message){
				MessageBox.error(message);
			}
		});
		event.preventDefault();
	});
	
/**
 * 
 */
//	$("#shorten-to-clipboard-button").click(function(event){
//		var longUrl = TinyLayer.readFromClipboard();
//		var shortenForm = $("#shorten-form");
//		var customElement = $("input[name=custom-hash]",shortenForm);
//		var needStats = $("input[name='log-stats']",shortenForm).prop("checked") ? 1 : 0;
//		TinyCC.shorten({
//			"url": longUrl,
//			"customHash": customElement.val(),
//			"needStats": needStats,
//			"successCallback": function(response){
//				MessageBox.show("URL shortened successfully!");
//				//console.log(response);
//				var urlEntry = response.results;
//				urlEntry.longUrl = longUrl;
//				RecentList.add(urlEntry);
//				
//				longUrlElement.val("");
//				customElement.val("");
//				
//				TinyLayer.copy(urlEntry.short_url);
//			},
//			"errorCallback": function(message){
//				MessageBox.error(message);
//			}
//		});
//		event.preventDefault();
//	});00.00
   
		$("#shorten-to-clipboard-button").click(function(event){
			var longUrlElement = $("#shorten-form input[name=long-url]");
			var customElement = $("#shorten-form input[name=custom-hash]");
			var needStats = $("#shorten-form input[name='log-stats']").prop("checked") ? 1 : 0;
			
			TinyLayer.readFromClipboard(function(longUrl)
			{
				longUrl = lowercaseURLScheme(longUrl);

				TinyCC.shorten({
						  "url": longUrl,
						  "customHash": customElement.val(),
						  "needStats": needStats,
						  "successCallback": function(response)
						  {
							  //MessageBox.show("URL shortened successfully!");
							  //console.log(response);
							  var urlEntry = response.results;
							  urlEntry.longUrl = longUrl;
							  
							  longUrlElement.val("");
							  customElement.val("");
							  TinyLayer.copy(urlEntry.short_url);
							  //cordova.plugins.clipboard.copy(urlEntry.short_url);

							  RecentList.add(urlEntry);
						  },
						  "errorCallback": function(message)
						  {
								MessageBox.error(message);
						  }
				  })
			});
			event.preventDefault();
		});
                  
                  
                  
                  
                  
                  
                  
                  
                  
/**
 * Delete recent URL action
 */
	$("body").on("click",".delete-recent-action",function(event){
		var hash = $(this).parents(".recent-url-entry").first().attr("data-url-hash");
		TinyLayer.confirm("Delete URL from recent list?", function(){ RecentList.remove(hash);});
		event.preventDefault();
	});
	
/**
 * Delete URL action
 */
	$("body").on("click",".delete-action",function(event){
		var hash = $(this).attr("data-url-hash");
		TinyLayer.confirm("Delete URL?", function(){ 
			UrlsList.remove(hash);
			window.location.hash="#manage";
		});
		event.preventDefault();
	});
   
/**
 * Get recent URL QR-code action
 */
	$("body").on("click",".qr-recent-action",function(event){
		var hash = $(this).parents(".recent-url-entry").first().attr("data-url-hash");
		openQrCodePopup(hash);
		event.preventDefault();
	});

/**
 * Get URL QR-code action
 */
   $("body").on("click",".qr-action",function(event){
	   var hash = $(this).attr("data-url-hash");
		openQrCodePopup(hash);
	   event.preventDefault();
	});
	
/**
 * Close QR-code popup
 */	
	$("#close-qr-code").click(function(event){
		$("#qrCodePopup").popup( "close" );
		event.preventDefault();
	});
   
/**
 * Share QR-code
 */
	$("#share-qr-code").click(function(event){
		var imgUrl = $("#qrCodePopup img").attr("src");
		TinyLayer.share(imgUrl);
		event.preventDefault();
	});   
	
/**
 * Download QR-code image
 */
	$("#download-qr-code").click(function(event){
		var imgUrl = $(this).attr("href");
		var imgName = "tiny_cc_"+($("#qrCodePopup").attr("data-url-hash"))+".png";
		
		TinyLayer.download(imgUrl, imgName);
		
		event.preventDefault();
	});   
	
/**
 * Share recent URL action
 */
	$("body").on("click",".share-recent-action",function(event){
		var hash = $(this).parents(".recent-url-entry").first().attr("data-url-hash");
		TinyLayer.share(RecentList.getShort(hash));
		event.preventDefault();
	});
	
/**
 * Share recent URL action
 */
	$("body").on("click",".share-action",function(event){
		var hash = $(this).attr("data-url-hash");
		TinyLayer.share(UrlsList.getShort(hash));
		event.preventDefault();
	});
   
/**
 * Copy recent URL action
 */
	$("body").on("click",".copy-recent-action",function(event){
		var hash = $(this).parents(".recent-url-entry").first().attr("data-url-hash");
		TinyLayer.copy(RecentList.getShort(hash));
		event.preventDefault();
	});   

/**
 * Copy URL action
 */
	$("body").on("click",".copy-action",function(event){
		var hash = $(this).attr("data-url-hash");
		TinyLayer.copy(UrlsList.getShort(hash));
		event.preventDefault();
	});   

/**
 * Navigate to special stats page
 */
	$("body").on("click",".stats-action",function(event){
		var hash = $(this).attr("data-url-hash");
		TinyLayer.popupBrowser(TinyCC.getPrivateStatsUrl(hash));
		event.preventDefault();
	});   
	
	
	
	
/**
 * Manage action button (goto Manage page)
 */
	$("body").on("click","#manage-action-button",function(event){
		switchMassDeleteModeOff();
		BusyIndicator.show();
		UrlsList.reload({
			"success":function(){ BusyIndicator.hide(); },
			"error":function(message){ BusyIndicator.hide();MessageBox.error(message); },
		});
	});  


/**
 * URLs list reload button on Manage page
 */
	$("body").on("click","#refresh-urls-button",function(event){
		BusyIndicator.show();
		UrlsList.reload({
			"success":function(){ BusyIndicator.hide(); },
			"error":function(message){ BusyIndicator.hide();MessageBox.error(message); },
		}, true);
		event.preventDefault();
	});

/**
 * URLs list search
 */
	var search_typing_timer;
	var search_done_typing_interval = 1000;

	function search_reload_data()
	{
		BusyIndicator.show();
		UrlsList.reload({
			"success":function(){ BusyIndicator.hide(); },
			"error":function(message){ BusyIndicator.hide();MessageBox.error(message); },
		}, true);
	}

	$(document).on('click', '.ui-input-clear', function ()
	{
		search_reload_data();
	});

	$("#manage-search-form input[name=search]").keyup(function(event)
	{
    	clearTimeout(search_typing_timer);
    	
	    if ($('#myInput').val)
	    {
    	    search_typing_timer = setTimeout(search_reload_data, search_done_typing_interval);
	    }
	});

	$("#manage-search-form").submit(function(event){
		BusyIndicator.show();
		UrlsList.reload({
			"success":function(){ BusyIndicator.hide(); },
			"error":function(message){ BusyIndicator.hide();MessageBox.error(message); },
		}, true);
		event.preventDefault();
	});
	
/**
 * URLs list sort
 */
	$("#sort-by").change(function(event){
		BusyIndicator.show();
		UrlsList.reload({
			"success":function(){ BusyIndicator.hide(); },
			"error":function(message){ BusyIndicator.hide();MessageBox.error(message); },
		}, true);
	});
	
/**
 * Goto URL details page
 */
	$("body").on("tap",".url-list-entry-container a",function(event){
		var hash = $(this).attr("data-url-hash");
		var urlInfo = UrlsList.getUrl(hash, true);
		switchMassDeleteModeOff();
		$("#details").html(TemplateEngine.use("template-UrlDetails",urlInfo));
		//$("#UrlDetailsHeader").toolbar();
		//$("#UrlDetailsFooter").toolbar();
	});
	
/**
 * Click to Adv Banner
 */
	$("body").on("click",".adv-banner",function(event){
		window.location = "http://google.com";
	});
	
/**
 * Reset stats action
 */
	$("body").on("click",".reset-stat-action",function(event){
		var hash = $(this).attr("data-url-hash");
		TinyLayer.confirm("Reset stats for this URL?",function(){
			UrlsList.resetStats(hash);
			// Reload URL details page
			$("#urls-list-container a[data-url-hash="+hash+"]").trigger("click");
		});
		event.preventDefault();
	});
	
/**
 * Toggle favorite action
 */
	$("#urls-list-container, #details").on("click",".favorite-star",function(event){
		var element = $(this);
		var hash = element.attr("data-url-hash");
		
		if(element.hasClass("favorite-status-1")){
			UrlsList.setFavorite(hash, 0);
			element.addClass("favorite-status-0");
			element.removeClass("favorite-status-1");
		}else{
			UrlsList.setFavorite(hash, 1);
			element.addClass("favorite-status-1");
			element.removeClass("favorite-status-0");
		}
		event.preventDefault();
	});
	
/**
 * Toggle QR mark
 */
	$("#details").on("click",".qr-switch",function(event){
		var element = $(this);
		var hash = element.attr("data-url-hash");
		
		if(element.hasClass("qr-status-1")){
			UrlsList.setQRMark(hash, 0);
			element.addClass("qr-status-0");
			element.removeClass("qr-status-1");
		}else{
			UrlsList.setQRMark(hash, 1);
			element.addClass("qr-status-1");
			element.removeClass("qr-status-0");
		}
		event.preventDefault();
	});

/**
 * Toggle Email Report 
 */
	$("#details").on("click",".email-report",function(event){
		var element = $(this);
		var hash = element.attr("data-url-hash");
		
		if(element.hasClass("email-stats-1")){
			UrlsList.setEmailReport(hash, 0);
			element.addClass("email-stats-0");
			element.removeClass("email-stats-1");
		}else{
			UrlsList.setEmailReport(hash, 1);
			element.addClass("email-stats-1");
			element.removeClass("email-stats-0");
		}
		event.preventDefault();
	});
	
/**
 * Toggle QR mark
 */
	$("#urls-list-container").on("click",".qrcode-switch",function(event){
		var element = $(this);
		var hash = element.attr("data-url-hash");
		
		if(element.hasClass("qrcode-status-1")){
			UrlsList.setQRMark(hash, 0);
			element.addClass("qrcode-status-0");
			element.removeClass("qrcode-status-1");
		}else{
			UrlsList.setQRMark(hash, 1);
			element.addClass("qrcode-status-1");
			element.removeClass("qrcode-status-0");
		}
		event.preventDefault();
	});
	
/**
 * Toggle mass delete mode
 */
	$("#mass-delete-button").click(function(event){
		var state = $(this).attr("data-state");
		if(state=="1"){
			switchMassDeleteModeOff();
		}else{
			$(".mass-delete-mode-visible").show();
			$(".mass-delete-mode-hidden").hide();
			$(this).attr("data-state","1")
		}
		event.preventDefault();
	});
 
	$("#mass-delete-check-all").click(function(event){
		$(".mass-delete-checkbox").prop("checked",true);
		event.preventDefault();
	});

	$("#mass-delete-uncheck").click(function(event){
		$(".mass-delete-checkbox").prop("checked",false);
		event.preventDefault();
	});
 
/**
 * Mass Delete URLs action
 */
	$("body").on("click","#mass-delete-do",function(event){
		var hashes=[];
		$(".mass-delete-checkbox:checked").each(function(){
			var hash = $(this).attr("data-url-hash");
			hashes.push(hash);
		});
		if(hashes.length>0){
			TinyLayer.confirm("Delete selected URLs?", function(){ 
				switchMassDeleteModeOff();
				UrlsList.massRemove(hashes);
			});
		}
		event.preventDefault();
	});
 
/**
 * Mass Delete checkboxes helper
 */
	$("body").on("click",".checkbox-helper",function(event){
		var cb = $(".mass-delete-checkbox",this);
		$(cb).prop("checked",!$(cb).prop("checked"));
		event.preventDefault();
		event.stopImmediatePropagation();
	}); 
 
/**
 * Prevend propagation of checkbox checking event
 */
	$("body").on("click",".mass-delete-checkbox",function(event){
		event.stopImmediatePropagation();
	});  
 
});

