/**
 * List of URLs on manage page
 */
var UrlsListWidget=$.extend({}, KBObserver.clone(), {
	init: function()
	{
		UrlsList.addObserver(this);
	},
	
	
	"notify":function(notificationType, data){
		switch(notificationType){
			case 'urlsListChanged':
				this["handle_"+notificationType](data);
			default:;
		}
	},
	
	handle_urlsListChanged: function(data){
		
		$("#urls-list-container").empty();
		if(data){
			for(var i=0; i<data.urls.length;i++)
			{
				$("#urls-list-container").append(TemplateEngine.use("template-UrlListEntry", data.urls[i]));
			}

			$("#urls-count").text(data.count);
		}
		
		//$( ".mass-delete-checkbox" ).checkboxradio( "refresh" );
	},
});

/**
 * Recent urls list winget
 */
var RecentUrlsListWidget=$.extend({}, KBObserver.clone(), {
	init: function()
	{
		RecentList.addObserver(this);
	},
	
	
	"notify":function(notificationType, data){
		switch(notificationType){
			case 'recentListChanged':
			case 'recentListAdd':
			case 'recentListRemove':
				this["handle_"+notificationType](data);
			default:;
		}
	},
	
	handle_recentListChanged: function(data){
		$("#recent-list-container").empty();
		for(var i=0; i<data.length;i++)
		{
			$("#recent-list-container").prepend(TemplateEngine.use("template-Recent", data[i]));
		}
	},

	handle_recentListAdd: function(data){
		$("#recent-list-container").prepend(TemplateEngine.use("template-Recent", data));
	},
	
	handle_recentListRemove: function(data){
			$(".recent-url-entry[data-url-hash='"+data+"']").remove();
	},


});

/**
 * Login button
 */
var LoginButtonWidget=$.extend({}, KBObserver.clone(), {
	init: function()
	{
		AccountModel.addObserver(this);
	},
	
	"notify":function(notificationType, data){
		switch(notificationType){
			case 'loginStateChanged':
				this["handle_"+notificationType](data);
			default:;
		}
	},
	
	handle_loginStateChanged: function(data){
		
		if(data && data.userName){
			$(".visible-for-guest").hide();
			$(".visible-for-user").show();
			$(".custom_domain").text(data.custom_domain);
		}else{
			$(".visible-for-guest").show();
			$(".visible-for-user").hide();
		}
		
	},
});



/**
 * Log stats switch
 */
var LogStatsSwitchWidget=$.extend({}, KBObserver.clone(), {
	init: function()
	{
		AccountModel.addObserver(this);
	},
	
	"notify":function(notificationType, data){
		switch(notificationType){
			case 'loginStateChanged':
				this["handle_"+notificationType](data);
			default:;
		}
	},
	
	handle_loginStateChanged: function(data){
		
		var switchBlock = $("#log-stats-switch-block");
		$("option",switchBlock).prop("selected", false);
		
		if(data && data.userName){
			switchBlock.hide();
			$("option[value=1]",switchBlock).prop("selected", true);
		}else{
			switchBlock.show();
			$("option[value=0]",switchBlock).prop("selected", true);
		}
		
	},
});


/**
 * Edit widget
 */
var EditWidget = {
	init: function()
	{
		var self = this;
		$("body").on("click",".edit-widget",function(event){
			var element = $(this);
			self.startEdit(element);
			event.preventDefault();
		});
	},
	
	startEdit: function(element)
	{
		var activeEditInput = $("#activeEditInput");
		if(activeEditInput.length){
			activeEditInput.trigger("focusout");
			return;
		}
		
		var self = this;
		var val = $(element).text();
		var limit = $(element).attr("data-limit");
		if(!limit)limit = 10000;
		$(element).hide();
		$(element).before("<input id='activeEditInput' type='text' value='"+val+"' maxlength='"+limit+"' style='width:98%'>");
		$("#activeEditInput").focusout( function(){ self.finishEdit(element); } ).trigger("focus");
	},
	
	finishEdit: function(element)
	{
		var resource = $(element).attr("data-resource");
		var hash = $(element).attr("data-url-hash");
		var value = $("#activeEditInput").val();
		UrlsList.editUrl({
			"hash":hash, 
			"property":resource, 
			"value":value,
			"successCallback":function(a){
				$("#activeEditInput").remove();
				$(element).text(value);
				$(element).show();
			}
		});
	},
	
};













